<?php
//record system settings for these before messing with them.
//Probably no real use to doing this, other than I feel like it.
function abbrevToBytes($bytestr)
{//given an abbreviated byte count [e.g. "25M", "2.5G"] returns 
//an integer value in bytes e.g. abbrevToBytes('25M') == 26214400
//Currently only handles K,M, and G - since this is for web-based
//file upload applications, I think the marginal usefulness of being
//able to handle whole-word forms (e.g. "25 megabyte") in an extremely 
//simple algorithm is still a little
//higher than being able to handle terabytes.
  $bytestr=trim(strtoupper($bytestr));
  $numberpart=preg_replace('/[[:^digit:].]/','',$bytestr); //don't think I need to escape the . in [] here do I?
  $letterpart=preg_replace('/[[:digit:]]/','',$bytestr);
  if(strpos($letterpart,'K')!==false) { //k, KB, "Kilobytes", etc.
    $numberpart=$numberpart*1024;
  } else if(strpos($letterpart,'M')!==false) { //m,MB,"Megabytes"...
    //also in before "Giga" just so the G in "Mega" doesn't trip things up
    $numberpart=$numberpart*1024*1024; 
  } else if(strpos($letterpart,'G')!==false) { //GB etc.
    $numberpart=$numberpart*1024*1024*1024;
  }
  return intval($numberpart); //for when wiseguys give decimals to the function...
}

$maxpost=ini_get('post_max_size');
$maxupload=ini_get('upload_max_filesize');
//convert abbreviated version to bytes

$memorylimit=ini_get('memory_limit');
$maxinputtime=ini_get('max_input_time');
$maxexecutetime=ini_get('max_execution_time');

//$maxwanted='268435456'; //256M. I'm assuming a quarter-GB is probably plenty for MOST shows
//'512M' (536870912) might be better - that's probably 90-100 minutes worth of stereo FLAC
//$maxwait='1800'; //number of seconds before reception times out
//I'm assuming nobody will wait more than half an hour for their upload to finish...

//ini_set('post_max_size',$maxwanted); //oops, only configurable in php.ini or .htaccess or whatever, not via ini_set
//ini_set('upload_max_filesize',$maxwanted);
//ini_set('max_input_time',$maxwait); 
//ini_set('max_execution_time',$maxwait); //this may be wrong - it's not clear whether input time
//actually counts as "execution time". However, since there shouldn't be anything in this script
//that'll take more than a few seconds even if something goes wrong (other than the file upload itself),
//It ought to be harmless to set this so high.

//If php is configured not to allow these to be adjusted, they may need to be altered in php.ini directly.

//**NOTE**: The web server might ALSO need to have the maximum POST size set to match, otherwise the web server will 
//kill the file upload even though PHP has been configured to handle it.
//for Apache, you MIGHT need to set "LimitRequestBody 268435456" in httpd.conf or .htaccess or whatever
//(Apache default for this is SUPPOSED to be 0 i.e. "don't limit", in which case this is unnecessary)
//for nginx, the setting would be "client_max_body_size 256M;"

?>
<!DOCTYPE html>
<html>
<head>
<title>HPR Submission Upload (prototype) Page</title>
</head>
<body>
<h1>Hacker Public Radio Submission Upload Page</h1>
<p title="This is just an introductory paragraph explaining what this page is for...">Here you may submit show audio for Hacker Public Radio. Just fill in the relevant form data, select whatever files you are uploading, and push
The Button (note: The Button won't actually exist until this form it functional...). Virtually all of the text on this page has an allegedly-helpful explanations that pop up if you
"hover" your pointer over it.</p>
<p title="Help for Beginners..."><b>New contributor to HPR? Remain calm, this is simpler than it looks!</b><br />
If you're not sure what to do here, do this:
<ol><li>Type your name/internet handle/pseudonyn in the field provided</li>
<li>Give us an email address where we can contact you for questions</li>
<li>Give your show a short title appropriate to its subject</li>
<li>Type in a "Short Summary" desribing the show in a sentence or so. We'll use this when announcing on "Twitter&reg;".</li>
<!-- <li>For the "Show Audio File", just click the button next to it and select the audio file that contains what you recorded. You don't <em>need</em> to worry about what kind of file it is if you don't want to.</li> -->
<li>We would appreciate it if you could also include a longer, more informative description of the show in the "Show Notes/Description" box, along with any supplemental information
(such as links for web pages mentioned in your show if any, citations for reference materials, or any other extra information that isn't in the audio). This will appear in the
text of the podcast feed, and will be embedded into the audio files we publish (so that people who want or need the information can extract it later). If you leave this blank,
we'll just use your "short summary" as the "Show Notes/Description".</li>
</ol>
You may then push "The Button" at the bottom of the form. If you hover your mouse cursor over (or in most cases, click on) any of the text in the form, you should see a description of what that part of the form is intended for.</p>
<p>(Tip: Mozilla Firefox users may want to install the <a href="https://addons.mozilla.org/en-US/firefox/addon/uploadprogress/" title="UploadProgress extension for Firefox" target="_New">UploadProgress extension for Firefox</a> so that you can watch the progress of the upload. It can take a while for large files!)</p>
<form name="HPRUpform" id="HPRUpform" enctype="multipart/form-data" action="takefile.php" method="POST">
<input type="hidden" name="MAX_FILE_SIZE" id="MAX_FILE_SIZE" value="<?php echo abbrevToBytes($maxupload); ?>" />
<!-- Yes, you can edit MAX_FILE_SIZE with a DOM editor or whatever but it'll do you no good - all this is for is to tell the script that receives the file what the
maximum size is supposed to be, so that if you're trying to send a larger file it'll abort before it wastes your time uploading until it hits the cap... -->
<!-- MAX_FILE_SIZE here is whatever the system's php.ini file is currently configured as the maximum file size to allow, the web server admin will have to adjust this if
it's too small -->
<span style="font-weight:bold;" title="Whatever name you want us to use when we credit you for your audio contributions. It doesn't really matter what this is, except that if you've contributed to HPR before, you should use the same name here that you used last time." onclick="alert(this.title);">Your HPR Name/Pseudonym (same as before, if this isn't your first submission):</span><input type="text" name="hprname" id="hprname" size="16" maxlength="30" /> 
<span style="font-weight:bold;" title="For 'this is not spam' confirmation, and the audio metadata. Might be limited to 30 characters because of crappy old mp3 limitations." onclick="alert(this.title);">Your email:</span><input type="text" name="hostemail" id="hostemail" size="16" maxlength="30"><span style="color:blue;text-decoration:underline;" title="There is none! We will sell your email to every political party organ, the CIA, Amway, and Apple Corporation and we'll be rich! RICH, I TELL YOU! (Okay, I actually don't have the text of the real privacy policy yet...)" onclick="alert(this.title);">(privacy policy)</span><br />
<span style="font-weight:bold;" title="What you are calling the show that you're uploading here. Due to crappy old mp3 limitations, this should be less than 30 characters" onclick="alert(this.title);">This show's title:</span><input type="text" name="showtitle" id="showtitle" size="30" maxlength="30" /><br />
<!-- <span style="font-weight:bold;" title="Any 'tags' relating to this show, its topic, yourself, etc. should be typed here, each term separated by a comma. If this is part of an ongoing 'series', the series name should be one of the tags. Don't worry about this if you don't know what this is." onclick="alert(this.title);">(Optional)Tags/Keywords for this show (separated by commas):</span><input type="text" name="hprtags" id="hprtags" size="16" maxlength="30" /><br /> -->
<span style="font-weight:bold;" title="A very brief summary of today's episode, limited to 100 characters so that there is room for it on HPR's twitter feed. If you are not supplying an audio summary yourself, this will also be used to generate the text-to-speech robot-voice summary that we play before your episode so that people who didn't read the text can decide whether they want to listen or not." onclick="alert(this.title);">Short summary (for twitter):</span><input type="text" name="showsummary" id="showsummary" size="64" maxlength="100" /><br />
<span style="font-weight:bold;" title="Virtually any file format is acceptable, but we prefer FLAC (at highest compression), Ogg Vorbis (-q8 preferred), or Ogg Opus (128kbit or better). If you're not sure about this, just upload whatever file came out of your recording device/software - we can nearly always handle whatever format you have. We'll email you back if we can't for some reason. NOTE: The maximum upload size here is determined by the web server's PHP settings. If the number shown here is too small, the web server administrator will need to fix it." onclick="alert(this.title);">Show Audio File (Max size: <?php echo $maxupload ?>):</span><input type="file" name="showaudio" id="showaudio" /><br />
<!-- <span style="font-weight:bold;" title="If you leave this unchecked, we will add the intro to the beginning and the outro to the end for you" onclick="alert(this.title);">Check Here IF you have already added the HPR Intro/Outro clips to your submission audio --&gt;</span>
<input type="checkbox" name="introoutro" id="introoutro" value="Intro/Outro Already Added" /><br /> -->
<!-- audio summary not yet in use at the admin side - commenting out for now 
<span style="font-weight:bold;" title="If you're recording your own summary rather than having it read out by a text-to-speech bot, upload it here. Otherwise, don't worry about this!" onclick="alert(this.title);">Pre-recorded show summary audio (optional!)</span><input type="file" name="showaudiosummary" id="showaudiosummary" /><br />  
-->
<span style="font-weight:bold;" title="This is where the full-length description of your show and/or the 'show notes' go. This will appear in the Hacker Public Radio feed entry as the show's description. This can be plain text or HTML code. No shenanigans with embedded Javascript, please, unless maybe that's what your show is about today." onclick="alert(this.title);">Paste or Type Show Notes/Description below:</span><br />
<textarea rows="10" cols="80" name="shownotes" id="shownotes"></textarea><br />
<!-- "supplemental files" not actually in use right now, commenting out 
<span style="font-weight:bold;" title="If you have an image file or files or other supplemental files linked from the show notes/description, upload them here.  If there are multiple files, please collect them into a single 'tarball' or .zip file for upload. (QUESTION: Would it be better to have a fixed number of possible supplemental file uploads instead of one?)" onclick="alert(this.title);">Supplemental Files (if applicable):</span><input type="file" name="snownotesmedia" id="shownotesmedia" /><br />
-->
<span style="font-weight:bold;" title="Select the copyright license terms you want your episode to be offered under. By default, we assume you want Creative Commons 'Attribution, Share-Alike', meaning anyone can use, remix, or redistribute your episode as long as they give you credit and also share their remixes under the same terms." onclick="alert(this.title);">Copyright license for this episode:</span><select name="cclicense" id="cclicense">
<option value="cc-by-sa" title="Anyone may remix or redistribute this episode, as long as they give you credit and share their remixes under the same terms">Attribution/Share-Alike</option>
<option value="cc-by-sa-nc" title="Anyone may remix or redistribute as long as they give you credit, share their remix under the same terms, AND are not using it for 'commercial' purposes, whatever that really means.">Attribution/Share-Alike/Non-Commercial</option>
</select>  
<span style="font-weight:bold;" title="Should this be scheduled as a regular show, or as backup for when we run out of regular shows?" onclick="alert(this.title);">Preferred Queue Priority</span><select name="queuepriority" id="queuepriority">
<option value="regular-priority" selected title="No special priority">Regular Priority</option>
<option value="lower-priority" title="Lower priority shows will be deferred until we're out of regular-priority shows in the queue.">Lower Priority</option>
</select>
<br />
<span style="font-weight:bold;" title="By default, we flag all shows 'explicit' just in case. If you're sure your show is 'family-friendly', say so here." onclick="alert(this.title);">Explicit?:</span>
<select name="explicit" id="explicit">
<option value="yes" selected title="Potentially explicit">Yes</option>
<option value="clean" title="clean">Clean</option>
</select><br />
<input type="submit" value="The Button" title="This is The Button. Push it when you finish putting in the information.">
</form>
</body>
</html>