<!DOCTYPE html>
<html>
<head>
<title>Receiving Submission...</title>
</head>
<body>
<?php
//takefile.php
//for Hacker Public Radio's submission upload page.
//This script receives the file(s) and information submitted by contributors,
//dumps the files into their own directory in the part of the filesystem 
//specified in the configuration, and generates some plain-text information
//files and an atom "<entry>" block for the HPR atom feed

/* Configuration Stuff
*Put whatever you feel appropriate here for the base directory to save
*submissions, whether to use UUID or the name/showtitle/timestamp
*as the pattern for the save directory, etc.
*/
$uuid=false; //leave "false" to save submission in directories named after timestamp/md5sum-of-uploaded-audio
//set "true" and the save directories will just be UUID (v4) codes
$savedir='/var/www/hprsubs'; //almost certain this should be something else, so change it...

$acceptedMetaData=array('showtitle','hprname','hostemail','showsummary','shownotes','cclicense','queuepriority','explicit');
//We're only going to touch pre-approved variables, and ignore anything else POSTed 

//$acceptedFiles=array('showaudio','showaudiosummary','shownotesmedia'); //not currently necessary...

/* uuid generation code shamelessly but legally lifted from elsewhere
as noted below... */

/*-
* Copyright (c) 2011 Fredrik Lindberg - http://www.shapeshifter.se
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
* notice, this list of conditions and the following disclaimer in the
* documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
* THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* Alternative this software might be licensed under the following license
*
* Copyright 2011 Fredrik Lindberg
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*
*/

/*
* UUID (RFC4122) Generator
* http://tools.ietf.org/html/rfc4122
*
* Implements version 1, 3, 4 and 5
*/
class UUID {
  /* UUID versions */
  const UUID_TIME	= 1;	/* Time based UUID */
  const UUID_NAME_MD5	= 3;	/* Name based (MD5) UUID */
  const UUID_RANDOM	= 4;	/* Random UUID */
  const UUID_NAME_SHA1	= 5;	/* Name based (SHA1) UUID */

  /* UUID formats */
  const FMT_FIELD	= 100;
  const FMT_STRING	= 101;
  const FMT_BINARY	= 102;
  const FMT_QWORD	= 1;	/* Quad-word, 128-bit (not impl.) */
  const FMT_DWORD	= 2;	/* Double-word, 64-bit (not impl.) */
  const FMT_WORD	= 4;	/* Word, 32-bit (not impl.) */
  const FMT_SHORT	= 8;	/* Short (not impl.) */
  const FMT_BYTE	= 16;	/* Byte */
  const FMT_DEFAULT	= 16;

  /* Field UUID representation */
  static private $m_uuid_field = array(
  'time_low' => 0,	/* 32-bit */
  'time_mid' => 0,	/* 16-bit */
  'time_hi' => 0,	/* 16-bit */
  'clock_seq_hi' => 0,	/* 8-bit */
  'clock_seq_low' => 0,	/* 8-bit */
  'node' => array()	/* 48-bit */
  );

  static private $m_generate = array(
  self::UUID_TIME => "generateTime",
  self::UUID_RANDOM => "generateRandom",
  self::UUID_NAME_MD5 => "generateNameMD5",
  self::UUID_NAME_SHA1 => "generateNameSHA1"
  );

  static private $m_convert = array(
  self::FMT_FIELD => array(
  self::FMT_BYTE => "conv_field2byte",
  self::FMT_STRING => "conv_field2string",
  self::FMT_BINARY => "conv_field2binary"
  ),
  self::FMT_BYTE => array(
  self::FMT_FIELD => "conv_byte2field",
  self::FMT_STRING => "conv_byte2string",
  self::FMT_BINARY => "conv_byte2binary"
  ),
  self::FMT_STRING => array(
  self::FMT_BYTE => "conv_string2byte",
  self::FMT_FIELD => "conv_string2field",
  self::FMT_BINARY => "conv_string2binary"
  ),
  );

  /* Swap byte order of a 32-bit number */
  static private function swap32($x) {
  return (($x & 0x000000ff) << 24) | (($x & 0x0000ff00) << 8) |
  (($x & 0x00ff0000) >> 8) | (($x & 0xff000000) >> 24);
  }

  /* Swap byte order of a 16-bit number */
  static private function swap16($x) {
  return (($x & 0x00ff) << 8) | (($x & 0xff00) >> 8);
  }

  /* Auto-detect UUID format */
  static private function detectFormat($src) {
  if (is_string($src))
  return self::FMT_STRING;
  else if (is_array($src)) {
  $len = count($src);
  if ($len == 1 || ($len % 2) == 0)
  return $len;
  else
  return (-1);
  }
  else
  return self::FMT_BINARY;
  }

/*
* Public API, generate a UUID of 'type' in format 'fmt' for
* the given namespace 'ns' and node 'node'
*/
  static public function generate($type, $fmt = self::FMT_BYTE,
  $node = "", $ns = "") {
  $func = self::$m_generate[$type];
  if (!isset($func))
  return null;
  $conv = self::$m_convert[self::FMT_FIELD][$fmt];
  
  $uuid = self::$func($ns, $node);
  return self::$conv($uuid);
  }

/*
* Public API, convert a UUID from one format to another
*/
  static public function convert($uuid, $from, $to) {
  $conv = self::$m_convert[$from][$to];
  if (!isset($conv))
  return ($uuid);

  return (self::$conv($uuid));
  }

/*
* Generate an UUID version 4 (pseudo random)
*/
  static private function generateRandom($ns, $node) {
  $uuid = self::$m_uuid_field;
  
  $uuid['time_hi'] = (4 << 12) | (mt_rand(0, 0x1000));
  $uuid['clock_seq_hi'] = (1 << 7) | mt_rand(0, 128);
  $uuid['time_low'] = mt_rand(0, 0xffff) + (mt_rand(0, 0xffff) << 16);
  $uuid['time_mid'] = mt_rand(0, 0xffff);
  $uuid['clock_seq_low'] = mt_rand(0, 255);
  for ($i = 0; $i < 6; $i++)
  $uuid['node'][$i] = mt_rand(0, 255);
  return ($uuid);
  }

/*
* Generate UUID version 3 and 5 (name based)
*/
  static private function generateName($ns, $node, $hash, $version) {
  $ns_fmt = self::detectFormat($ns);
  $field = self::convert($ns, $ns_fmt, self::FMT_FIELD);

  /* Swap byte order to keep it in big endian on all platforms */
  $field['time_low'] = self::swap32($field['time_low']);
  $field['time_mid'] = self::swap16($field['time_mid']);
  $field['time_hi'] = self::swap16($field['time_hi']);

  /* Convert the namespace to binary and concatenate node */
  $raw = self::convert($field, self::FMT_FIELD, self::FMT_BINARY);
  $raw .= $node;

/* Hash the namespace and node and convert to a byte array */
  $val = $hash($raw, true);	
  $tmp = unpack('C16', $val);
  foreach (array_keys($tmp) as $key)
  $byte[$key - 1] = $tmp[$key];

/* Convert byte array to a field array */
  $field = self::conv_byte2field($byte);
  
  $field['time_low'] = self::swap32($field['time_low']);
  $field['time_mid'] = self::swap16($field['time_mid']);
  $field['time_hi'] = self::swap16($field['time_hi']);
  
/* Apply version and constants */
  $field['clock_seq_hi'] &= 0x3f;
  $field['clock_seq_hi'] |= (1 << 7);
  $field['time_hi'] &= 0x0fff;
  $field['time_hi'] |= ($version << 12);

  return ($field);	
  }
  static private function generateNameMD5($ns, $node) {
  return self::generateName($ns, $node, "md5",
  self::UUID_NAME_MD5);
  }
  static private function generateNameSHA1($ns, $node) {
  return self::generateName($ns, $node, "sha1",
  self::UUID_NAME_SHA1);
  }

/*
* Generate UUID version 1 (time based)
*/
  static private function generateTime($ns, $node) {
  $uuid = self::$m_uuid_field;

/*
* Get current time in 100 ns intervals. The magic value
* is the offset between UNIX epoch and the UUID UTC
* time base October 15, 1582.
*/
  $tp = gettimeofday();
  $time = ($tp['sec'] * 10000000) + ($tp['usec'] * 10) +
  0x01B21DD213814000;
  
  $uuid['time_low'] = $time & 0xffffffff;
  /* Work around PHP 32-bit bit-operation limits */
  $high = intval($time / 0xffffffff);
  $uuid['time_mid'] = $high & 0xffff;
  $uuid['time_hi'] = (($high >> 16) & 0xfff) | (self::UUID_TIME << 12);

/*
* We don't support saved state information and generate
* a random clock sequence each time.
*/
  $uuid['clock_seq_hi'] = 0x80 | mt_rand(0, 64);
  $uuid['clock_seq_low'] = mt_rand(0, 255);

/*
* Node should be set to the 48-bit IEEE node identifier, but
* we leave it for the user to supply the node.
*/
  for ($i = 0; $i < 6; $i++)
  $uuid['node'][$i] = ord(substr($node, $i, 1));

  return ($uuid);
  }

/* Assumes correct byte order */
  static private function conv_field2byte($src) {
  $uuid[0] = ($src['time_low'] & 0xff000000) >> 24;
  $uuid[1] = ($src['time_low'] & 0x00ff0000) >> 16;
  $uuid[2] = ($src['time_low'] & 0x0000ff00) >> 8;
  $uuid[3] = ($src['time_low'] & 0x000000ff);
  $uuid[4] = ($src['time_mid'] & 0xff00) >> 8;
  $uuid[5] = ($src['time_mid'] & 0x00ff);
  $uuid[6] = ($src['time_hi'] & 0xff00) >> 8;
  $uuid[7] = ($src['time_hi'] & 0x00ff);
  $uuid[8] = $src['clock_seq_hi'];
  $uuid[9] = $src['clock_seq_low'];

  for ($i = 0; $i < 6; $i++)
  $uuid[10+$i] = $src['node'][$i];

  return ($uuid);
  }

  static private function conv_field2string($src) {
  $str = sprintf(
  '%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x',
  ($src['time_low']), ($src['time_mid']), ($src['time_hi']),
  $src['clock_seq_hi'], $src['clock_seq_low'],
  $src['node'][0], $src['node'][1], $src['node'][2],
  $src['node'][3], $src['node'][4], $src['node'][5]);
  return ($str);
  }

  static private function conv_field2binary($src) {
  $byte = self::conv_field2byte($src);
  return self::conv_byte2binary($byte);
  }

  static private function conv_byte2field($uuid) {
  $field = self::$m_uuid_field;
  $field['time_low'] = ($uuid[0] << 24) | ($uuid[1] << 16) |
  ($uuid[2] << 8) | $uuid[3];
  $field['time_mid'] = ($uuid[4] << 8) | $uuid[5];
  $field['time_hi'] = ($uuid[6] << 8) | $uuid[7];
  $field['clock_seq_hi'] = $uuid[8];
  $field['clock_seq_low'] = $uuid[9];

  for ($i = 0; $i < 6; $i++)
  $field['node'][$i] = $uuid[10+$i];
  return ($field);
  }

  static public function conv_byte2string($src) {
  $field = self::conv_byte2field($src);
  return self::conv_field2string($field);
  }

  static private function conv_byte2binary($src) {
  $raw = pack('C16', $src[0], $src[1], $src[2], $src[3],
  $src[4], $src[5], $src[6], $src[7], $src[8], $src[9],
  $src[10], $src[11], $src[12], $src[13], $src[14], $src[15]);
  return ($raw);
  }

  static private function conv_string2field($src) {
  $parts = sscanf($src, '%x-%x-%x-%x-%02x%02x%02x%02x%02x%02x');
  $field = self::$m_uuid_field;
  $field['time_low'] = ($parts[0]);
  $field['time_mid'] = ($parts[1]);
  $field['time_hi'] = ($parts[2]);
  $field['clock_seq_hi'] = ($parts[3] & 0xff00) >> 8;
  $field['clock_seq_low'] = $parts[3] & 0x00ff;
  for ($i = 0; $i < 6; $i++)
  $field['node'][$i] = $parts[4+$i];

  return ($field);
  }

  static private function conv_string2byte($src) {
  $field = self::conv_string2field($src);
  return self::conv_field2byte($field);
  }

  static private function conv_string2binary($src) {
  $byte = self::conv_string2byte($src);
  return self::conv_byte2binary($byte);
  }
}
/* -- end of imported UUID generation code -- */

function destDirName($metadata=array(),$uuid=false)
{//creates a unique name to use for directory for this submission
//if $uuid is passed (and ==true) it will use that hideous
//"uuid" monstrosity to generate a directory name based on a
//meaningless giant "random number so big that probably nobody
//else using the same algorithm will generate the same number" string
//if not, it will check that $metadata array for "uploadmd5" (md5sum of the uploaded audio file)
//and combine with timestamp to create the new directory name
//(If no parameters are passed at all, the returned name will JUST be a timestamp down to seconds)
//returns the path to the directory assuming it was successfully created
//returns false if the directory couldn't be created
//TODO: evaluate whether timestamp is desirable/necessary - leaving it out would let
//a submitter go back and re-submit material from the same form if necessary but
//could open up some risk of others overwriting/replacing the submission if they know the name/showtitle exactly
//Not sure how useful that would be but it's a thought...
  if ($uuid) {
    $dirname=UUID::generate(UUID::UUID_RANDOM, UUID::FMT_STRING);
  } else { //do something a bit more informative...
    //$dirname=date('c'); //extended-format ISO8601 timestamp
    $dirname=gmdate('Ymd').'T'.date('His').'Z'; //basic form iso8601 timestamp, in UTC regardless of local time (as opposed to date())
    /* we're changing the format - now it's timestamp/md5sum-of-uploaded-file...
    //it is not entirely impossible that two submitters will both submit files that finish uploading
    //get processed at exactly the same second, so we include the relatively useful information of
    //the submitter's name and show title, "sanitized" down to just alphanumeric characters for safety.
    if($metadata['hprname']) { //this script shouldn't even get here if the name isn't included, but I'll check anyway
      $dirname=preg_replace('/\W/','',$metadata['hprname']); //gets around shenanigans of people putting their name as "/etc/shadow" or whatever...  
    }
    if($metadata['showtitle']) { //like hprname, if showtitle isn't existent it shouldn't even get here, but...
      $dirname='-'.preg_replace('/\W/','',$metadata['showtitle']);
    }
    //$dirname.='-'.date('Ymd').'T'.date('His');
    */ 
    if(isset($metadata['uploadmd5'])) {
      $dirname.='-'.$metadata['uploadmd5'];
    }
  } 
  return $dirname; //this will just be a timestamp if no $metadata was passed and $uuid was false
  
}

function genAtomEntry($metadata)
{//given an array of fieldname->value pairs from the submission form data, 
//this pulls out what it recognizes as relevant and generates an atom xml <entry> item
//which is intended as a template to be inserted into the HPR atom feed once
//the missing information (i.e. the final file name, "updated" date, etc.)
//is known and inserted

//We should expect the submission form will provide the show title, an "author" name/pseudonym, an email address,
//"summary text" (short "twitter-style" description), and "show notes" (long-form description/information).
//We may or may not get tags [we should supply at least one as a "default" tag as well]. We can get the published
//("uploaded") date just by checking date() when the script runs of course. This information will be automatically
//filled in by this function.

//NOTE: I originally completely misunderstood what was wanted here - rather than and ATOM entry destined
//for direct insertion into the HPR show feed, this is intended to be an internal atom entry for the 
//processing system to use. Information will be taken from it and XSLT'd to generate the HPR feed entries.
//changes to reflect the internal directory name, etc. are a result of this.  Otherwise this is not a major change.

//returns the template xml text as a string, which the administrator 
//will only need to XSLT-process to add whatever additional information is needed
//(episode number, file sizes, "updated"(feed) date, tags [from metadata]) to fill in on release day - this ought to be scriptable.

//ALSO TODO: I would have sworn there was some standardized way to include copyright license info - if not, we can append it at the end of the
//long-form description [i.e. "show notes"] which is what I'm doing for now.

/* example feed...we can abuse <category> for miscellaneous tags where <category term="(field name)">(field value)</category>

//ADDITIONAL NOTE: Having multiple enclosures of different types is perfectly legal, but I don't know how well 'podcatchers' are
//currently handling that. For now, we're generating an entry template with all types included, but we may need/want to change
//this to a single enclosure link with the "type" being find-and-replaced instead, along with the file extension e.g.
//<link rel="enclosure"
//	type="#MIMETYPE#"
//	title="#SHOWTITLE"
//	href="http://hackerpublicradio.org/eps/hpr#EPNUMBER#.#FILEEXT#"
//	length="#FILELENGTH#" />

<entry>
    <id>http://hackerpublicradio.org/eps.php?id=#EPNUMBER#</id>
    <title>#SHOWTITLE#</title>
    <updated>#FEEDDATE#</updated>
    <published>#UPLOADDATE#</published>
    <author>
         <name>#HPRNAME#</name>
         <uri>#HOSTURL#</uri>
         <email>#HOSTEMAIL#</email>
    </author>
    <category term="#TAG#">#TAGVALUE#</category>
    <link href="http://hackerpublicradio.org/eps.php?id=#EPNUMBER#" />
    <summary>#SUMMARYTEXT#</summary>
    <link rel="enclosure" 
          type="audio/ogg; codecs=opus" //not sure if "codecs=" is legal in this context...
          title="#SHOWTITLE#"
          href="http://hackerpublicradio.org/eps/hpr#EPNUMBER#.opus"
          length="#OPUSLENGTH#" />
    <link rel="enclosure" 
          type="audio/ogg"
          title="#SHOWTITLE#"
          href="http://hackerpublicradio.org/eps/hpr#EPNUMBER#.ogg"
          length="#OGGLENGTH#" />
    <link rel="enclosure" 
          type="audio/ogg"
          title="#SHOWTITLE#"
          href="http://hackerpublicradio.org/eps/hpr#EPNUMBER#.spx"
          length="#SPXLENGTH#" />
    <link rel="enclosure" 
          type="audio/mpeg"
          title="#SHOWTITLE#"
          href="http://hackerpublicradio.org/eps/hpr#EPNUMBER#.mp3"
          length="#MP3LENGTH#" />

    <content type="html">
      #SHOWNOTES#
    </content>
</entry>\
*/
  $knownFields=array('showtitle','hprname','hostemail','showsummary','shownotes','cclicense',
		    'idcode','destdir','showaudiofile','showaudiotype','showaudiosize','shownotesfile','shownotesize'); // 'hosturl' as well?
  $htmlOkay=array('showsummary','shownotes'); //fields allowed to include HTML tags - others will be passed through htmlentities() for sanitization
  $givenFields=array_keys($metadata);
  foreach($knownFields as $fieldname) {
    $$fieldname='#'.strtoupper($fieldname).'#'; //default value easily find/replaced later via sed or similar method if necessary
    if($metadata[$fieldname]) {
      if(in_array($fieldname,$htmlOkay)) {
	$$fieldname=$metadata[$fieldname];
      } else {
	$$fieldname=htmlentities($metadata[$fieldname],ENT_NOQUOTES | ENT_HTML5, "UTF-8");
      }
    }
  }
  $now=date('c'); 
  $entrytext="
  <entry>
    <id>$idcode</id>
    <title>$showtitle</title>
    <updated>$now</updated>
    <published>$now</published>
    <author>
         <name>$hprname</name>
         <uri>http://hackerpublicradio.org</uri>
         <email>$hostemail</email>
    </author>\n";
    //if/when we start using categories/tags, insert those here.
    //for now I'm assuming we're skipping it...
    //$entrytext.="<category term=\"tag\">#TAGNAME#</category>\n";
    $entrytext.="
    <link href=\"sftp://hackerpublicradio.org/$destdir\" />
    <summary>$showsummary</summary>
    <link rel=\"enclosure\"
	  type=\"$showaudiotype\"
	  title=\"$showtitle\"
	  href=\"sftp://hackerpublicradio.org/$showaudiofile\"
	  length=\"$showaudiosize\" />
    <link rel=\"enclosure\"
	  type=\"text/plain\"
	  title=\"$showtitle Show Notes\"
	  href=\"sftp://hackerpublicradio.org/$shownotesfile\"
	  length=\"$shownotesize\" />";
	  
    /*
    <link rel=\"enclosure\" 
          type=\"audio/ogg; codecs=opus\" 
          title=\"$showtitle\"
          href=\"http://hackerpublicradio.org/eps/hpr0000.opus\"
          length=\"0\" />
    <link rel=\"enclosure\" 
          type=\"audio/ogg\"
          title=\"$showtitle\"
          href=\"http://hackerpublicradio.org/eps/hpr0000.ogg\"
          length=\"0\" />
    <link rel=\"enclosure\" 
          type=\"audio/ogg; codecs=speex\"
          title=\"$showtitle\"
          href=\"http://hackerpublicradio.org/eps/hpr0000.spx\"
          length=\"0\" />
    <link rel=\"enclosure\" 
          type=\"audio/mpeg\"
          title=\"$showtitle\"
          href=\"http://hackerpublicradio.org/eps/hpr0000.mp3\"
          length=\"0\" />
    */
    $entrytext.="
    <content type=\"xhtml\">
      <div>$shownotes\n</div>
    </content>
</entry>\n";

return $entrytext;
}
print("<h1>Going...</h1>\n");

//Okay, we should definitely have $_FILES['showaudio']. We MIGHT have $_FILES['showaudiosummary'], and just occasionally $_FILES['shownotesmedia']
if(!$_FILES['showaudio']['tmp_name']||$_FILES['showaudio']['error']||($_FILES['showaudio']['size']<1)) {
  print("<h1>Like, DUDE! Something went wrong!</h1>\n");
  if($errorcode=$_FILES['showaudio']['error']) { 
    //if(($errorcode==UPLOAD_ERR_FORM_SIZE)||($errorcode==UPLOAD_ERR_INI_SIZE)) { //file too big or server configuration too small...
    if(($errorcode==UPLOAD_ERR_INI_SIZE)) {
      die("<h2>Your show media file was larger than the web server was configured to accept!</h2><p>Tell the server administrator!</p>\n");
    } elseif($errorcode==UPLOAD_ERR_PARTIAL) {
      die("<h2>Your show media file upload was interrupted before it finished.</h2>\n");
    } elseif(($errorcode==UPLOAD_ERR_NO_TMP_DIR)||($errorcode==UPLOAD_ERR_CANT_WRITE)) {
      die("<h2>The server could not save the uploaded file</h2><p>For some reason, the server was unable to write the file upload to disk. Tell the server administrator!</p>\n");
    } 
    elseif($errorcode==UPLOAD_ERR_EXTENSION ) {
      die("<h2>Some PHP extension killed the upload of your media file!</h2><p>The server administrator will have to investigate this. Some unknown PHP extension caused the file upload to fail.</p>\n");
    } 
    else {
      die("<p>For some reason, we did not actually receive a show media file from you. Please try again or contact an administrator for help.</p>");
    }
  } //no actual error code, but we still don't have a usable media file...this should not happen, but if it does:
  if($_FILES['showaudio']['size']<1) {//actually, as far as I know this should never be a negative number, but just in case...
    die("<h2>Uploaded file was empty</h2><p>For some reason, we got no actual show audio data from your upload. Please try again or ask an administrator for help.</p>");
  } else {
    die("<h2>But we don't know what!</h2><p>The server did not report any errors, but we still have no show audio file from your upload. Please let an administrator know that this happened, because hypothetically it shouldn't.</p>\n");
  }
} 

//Okay, we have a show file, there's data in it, and no errors were flagged - go ahead and process...
$submitMetaData=array();
foreach($acceptedMetaData as $fieldname) {
  $submitMetaData[$fieldname]=$_REQUEST[$fieldname];
}
$submitMetaData['uploadmd5']=md5_file($_FILES['showaudio']['tmp_name']); 
$basename=destDirName($submitMetaData,$uuid);
$submitMetaData['idcode']=$basename;
$submitdir="$savedir/$basename";
$submitMetaData['destdir']=$submitdir;
//make sure we can make the save directory
if(!mkdir($submitdir,0750)) { //we cannot haz directory
  $submitdir=sys_get_temp_dir(); //rather than just waste a potentially long upload...
}
//check uploaded audio mimetype
$saveshowaudio="$submitdir/$basename-showaudio.".end(explode('.', $_FILES['showaudio']['name']));
if(!move_uploaded_file($_FILES['showaudio']['tmp_name'],$saveshowaudio)) {
  die("<h1>Like, DUDE! Something went wrong!</h1><h2>This sucks, but for some reason we couldn't move your uploaded audio for processing. Tell the admin...</h2><p>We can't do anything without this working - aborting.</p>");
} else {
  $finfo=finfo_open(FILEINFO_MIME_TYPE);
  $showaudiotype=finfo_file($finfo,$saveshowaudio);
  $showaudiosize=filesize($saveshowaudio);
  print("<h1>Show audio saved for processing!</h1>\n");
}

//show audio summary and supplemental files not currently being used, just comment these out...
/*
if($_FILES['showaudiosummary']['tmp_name']&&$_FILES['showaudiosummary']['size']) {
  if(!move_uploaded_file($_FILES['showaudiosummary']['tmp_name'],"$submitdir/$basename-audiosummary.".end(explode('.', $_FILES['showaudiosummary']['name'])))) {
    print("<h1>WARNING: Failed to save your audio summary file.</h1><h2>You may want to let the administrator know.</h2>\n");
  } else {
    print("<h2>Saved your pre-recorded audio summary file...</h2>\n");
  }
} else {
  print("<h2>(No pre-recorded audio summary provided. This summary may be provided by the HPR text-to-speech bot.)</h2>\n");
}
if($_FILES['shownotesmedia']['tmp_name']&&$_FILES['shownotesmedia']['size']) {
  if(!move_uploaded_file($_FILES['shownotesmedia']['tmp_name'],"$submitdir/$basename-supplemental.".end(explode('.', $_FILES['shownotesmedia']['name'])))) {
    print("<h1>WARNING: Failed to save your supplemental media file.</h1><h2>You may want to let the administrator know.</h2>\n");
  } else {
    print("<h2>Saved your supplemental file...</h2>\n");
  }
} else {
  print("<h2>(No supplemental file uploaded)</h2>\n");
}
*/
$submitMetaData['showaudiofile']=$saveshowaudio;
$submitMetaData['showaudiotype']=$showaudiotype;
$submitMetaData['showaudiosize']=$showaudiosize;

$shownotetext=$submitMetaData['hprname'].' ('.$submitMetaData['hostemail'].")\n\n";
$shownotetext.=$submitMetaData['showtitle']."\n\n";
$shownotetext.="Priority: ".$submitMetaData['queuepriority']."\n\n";
//$shownotetext.=$submitMetaData['tags']."\n\n"; //This isn't in the form yet...
$shownotetext.="Series/Tags: \n\n";
$shownotetext.=$submitMetaData['showsummary']."\n\n";
$shownotetext.=$submitMetaData['shownotes']."\n".$submitMetaData['cclicense']."\n";
$shownotefile="$submitdir/$basename.txt";
$submitMetaData['shownotesfile']=$shownotefile;
$submitMetaData['shownotesize']=strlen($shownotetext);
if($filehandle=fopen("$shownotefile",'w')) {
  fwrite($filehandle,$shownotetext);
  fclose($filehandle);
  print("<h2>Text show notes saved...</h2>\n");
} else {
  print("<h1>WARNING: Couldn't save text show notes for some reason.</h1>\n");
}

$atomtemplate=genAtomEntry($submitMetaData);

if($filehandle=fopen("$submitdir/$basename.xml",'w')) {
  fwrite($filehandle,$atomtemplate);
  fclose($filehandle);
  print("<h2>Save atom entry template for your submission...</h2>\n");
} else {
  print("<h1>WARNING: Couldn't save Atom entry template for some reason.</h1>\n");
}

print("<h1>Thanks for the submission!</h1>\n");
print("<p>An administrator will contact you at the email address you provided if we need anything else.</p>\n");
?>


</body>
</html>